## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## JZoC by Jeckel.
##

from CvPythonExtensions import *

import Popup as PyPopup
import CvUtil
import CvEventManager

import CvConfigParser
import CvPath

import CvJZoCGameUtils


# globals
gc = CyGlobalContext()

jz = CvJZoCGameUtils.JZoC()

#########################################################################

# This option allows you to turn this mod on/off.
# True - This will activate the JFort Mod.
# False - This will deactivate the JFort Mod.
# Default = True
g_bJZoCFeaturesEnabled = True

#########################################################################


def loadConfigurationData():
	global g_bJZoCFeaturesEnabled

        # Load the JRandomNames Mod Config INI file containing all of the configuration information
	config = CvConfigParser.CvConfigParser("JZoC Mod Config.ini")

	# If the JRandomNames Mod's config.ini file was found then load its values
	if(config != None):
                g_bJZoCFeaturesEnabled = config.getboolean("JZoC Mod", "JZoC Features Enabled", True)


class CvJZoCEventManager:
	def __init__(self, eventManager):
                # initialize base class

                eventManager.addEventHandler("unitMove", self.onUnitMove)
                eventManager.addEventHandler("improvementBuilt", self.onImprovementBuilt)

	def onUnitMove(self, argsList):

                if (g_bJZoCFeaturesEnabled):
                        jz.onUnitMove(argsList)
		
	def onImprovementBuilt(self, argsList):

                if (g_bJZoCFeaturesEnabled):
                        jz.onImprovementBuilt(argsList)


















